/* FIXMAHAL.C: Multivariate Fixed Point Clusters; outlier identification
by Mahalanobis distance, with missing values and grouping, Dec. 1998 */

/* Die Bemerkung TZ kennzeichnet nur zu Testzwecken sinnvolle Zeilen. */
/* TZ */
#ifdef dos
#include <alloc.h> /* Use only under DOS */
#endif
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <time.h>
#ifdef dos
#include <dos.h> /* Use only under DOS */
#endif
#include "fixdefs.h"
#include "vfm.h"
#include "loklesen.h" /* benoetigt lokglo */
#include "lokstan.h"  /* benoetigt standard */
#include "meancov.h"
#include "matrix.h"

#ifdef dos  /* comment out if not compiled by make */
extern unsigned _stklen=55000; /* Use only under DOS */
#endif   /* comment out if not compiled by make */

/* Grundablauf */
int durchlauf(double, int); /* gamma, Nummer, Rueckgabe: Abbruch ? */
int stop(int); /* Zaehlvariable; Ausgabe: Abbruch */

/* Prognosebereich, Ueberpruefung und Entscheidung ueber Cluster */
int prog(double); /* gamma, Rueckgabe: Indikator 1, wenn sich etwas geaendert hat */
int vorhanden(double); /* gamma, Rueckgabe: Nummer der vorhandenen Cluster */
int xqgleich(double, int); /* gamma, Clusternr.; Rueckgabe: 1, falls bereits vorhanden */
int clgleich(double, int); /* gamma, Clusternr.; Rueckgabe: 1, falls bereits vorhanden */

/* Verschiedene Ausgabefunktionen */
void xqausgabe(void);
void sausgabe(int); /* Matrix invertierbar */
void indausgabe(int); /* Ausgabestop */
int grausgabe(int); /* Ausgabestop, Rueckgabe: n2 */
void vausgabe(double d1[], int);
void rausgabe(void);
void tabausgabe(void);

FILE *out;
vektor x[NKOR], mx, dx, s[PKOR], xq, vr[NKOR];
/* x-Werte, Median x, Dispersion x, Kovarianzmatrix, Mittelwertvektor, Abstandsvektor */

double r[NKOR], g1, g2, chial;
/* Mahalanobisvektor,
Gamma 1.Durchgang, Gamma 2. Durchgang,
Konstante fuer Ausreisserklassifikation */

int n, n2, p, gi[NKOR], gj[NKOR], gk[NKOR], gl[NKOR], gm[NKOR], ind2, mco, rco,
    mult, scz1, scz2, ico, mcg, auco, group[NKOR], gnummer[NKOR], ngr, gvco;
/* n, n der aktuellen Cluster, p, i in aktuellem Cluster ?, i in Allescluster 1 ?,
i in Allescluster 2 ?, Wahrscheinlichkeiten fuer Ziehung, i in relevantem Cluster ?,
ind2: 2 fuer Allescluster-Iteration, 1 fuer normale Iteration, 3 fuer manuellen
Cluster, 0, falls Allescluster in normaler Iteration gefunden (in prog auch
fuer zu kleine oder bereits vorhandene Cluster);
Relevanzentscheidung vom Programm,
Manuelle Relevanzentscheidung ?,
Wahrscheinlichkeitsmultiplikator, Clusterzaehler (gamma1, gamm2),
Identifikatoren, Mindestclustergroesze, zwei
hintereinanderfolgende Iterationen,
Gruppierungsvariable
fuer Suchstart, interne Nummer der Gruppe, ngr: Zahl der Gruppen, Gruppierung erwuenscht? */

char outname[NLEN], dateiname[NLEN], id[NKOR][VLEN], varname[PKOR+3][VLEN];

static FILE *out2;

static double *gx1[PKOR], *gx2[PKOR], *gs1[PKOR][PKOR], *gs2[PKOR][PKOR];
/* Mittelwertvektoren der verschiedenen Cluster (gamma1, gamma2),
Kovarianzmatritzen der gamma-1/2-Cluster */

static double invers=0;
/* Kovarianzmatrix invertierbar? */

static int *gz1, *gz2, *cn;
/* Wie haeufig wurden die Cluster gefunden ?, Clusternummer 2, die zu
Level-1-Cluster gehoert */

static int ad, zad=0, heapco=1, d1co=0, agn,
           convstop=0, d, isl;
/* ad: Anzahl der Iterationlaeufe (gewuenscht/zusaetzlich),
heap memory reicht,
Gerade Level-1-Cluster gefunden?,
aktuelle Gruppennummer, nicht fertig iterierte Konfigurationen,
Iterationsnummer, Hoechstzahl der Iterationsschritte */


void main(void)
{
  double rand02, sf;
  int i, q, j, sg, sco, stanco, stanco1=0, wco, ind3, invers, agroup;
  /* sg: Startclustergroesze, sco: Endabfrage,
     ind3=0: Fuer g1 Iteration nicht durchgefuehrt, weil Skala zu grosz;
     invers: 0, wenn LS-Schaetzer-Matrix singulaer, alte Gruppe */

  char co[]= "ll", jn[2][6], *yes="yes", *no="no";

  eingabe();
  srand( (unsigned)time(NULL) );
  strcpy (jn[1], yes); strcpy (jn[0], no);
/*  printf ("Free heap memory: %lu \n",coreleft()); */
  scz1=scz2=0;
  gz1= (int *) malloc(sizeof(int));
  gz2= (int *) malloc(sizeof(int));
  cn= (int *) malloc(sizeof(int));
  for (i=0; i<p; ++i)
  {
    for (j=0; j<p; ++j)
    {
      gs1[i][j]= (double *) malloc(sizeof(double));
      gs2[i][j]= (double *) malloc(sizeof(double));
    }
    gx1[i]= (double *) malloc(sizeof(double));
    gx2[i]= (double *) malloc(sizeof(double));
  }
  if (gvco)
  {
    gnummer[0]=-1;
    j=0;
    agroup=-2;
    while (gnummer[j]>agroup)
    {
      agroup=gnummer[j];
      for (i=0; i<n; ++i)
      {
        if (group[i]>agroup && (group[i]<=gnummer[j] || gnummer[j]==agroup))
        {
	  gnummer[j]=group[i];
          if (gnummer[j]==agroup+1)
            i=n;
        } /* if group */
      } /* for i */
      ++j;
      gnummer[j]=gnummer[j-1];
    } /* while gnummer>agroup */
    ngr=j-1;
  } /* if gvco */
  sg=p+1;
  ad=100*pow(3,p-1); g1=0.01; g2=0.002; mco=0; mult=1; sco=0; chial=0; auco=0;
  mcg=2*(p+1); stanco=0; wco=0; rco=0;
  isl=n;
  if (n>5000)
    isl=5000;
  while (co[0]!='q')
  {
    printf("\n\nSettings for cluster search:\n");
    printf("(*) indicates test functions for curious users; possibly unstanble or useless.\n");
    printf("       a) %d runs,\n",ad);
    printf("       b) (*) Increase factor of search probability for data not included in \n");
    printf("          clusters: %d (integer !),\n", mult);
    printf("       c) (*) Two different levels for cluster search: %s\n",jn[auco]);
    if (auco)
      printf("       d) Weaker level %7.5f (=>Mahalanobis-cutoff c %5.3f)\n", g1, chiinv (p,1-g1));
    printf("       e) Standard level %7.5f (=>Mahalanobis-cutoff c %5.3f)\n",g2, chiinv (p,1-g2));
    printf("       f) (*) Number of data points for search start: %d \n", sg); \
    printf("       g) (*) Do you want to get a question for break all 20 runs: %s\n",jn[sco]);
    printf("       h) Minimum size of clusters: %d \n", mcg);
    printf("       i) Output of standardized values (median and dispersion): %s \n",jn[stanco]);
    printf("       j) (*) Do you want to be asked for the relevance of the clusters: %s \n",jn[rco]);
    printf("       k) (*) Do you want to enter points with decreased search probability: %s \n",jn[wco]);
    if (auco)
      printf("       l) Input of Mahalanobis-cutoff for weaker level\n");
    printf("       m) Input of Mahalanobis-cutoff for standard level\n");
    printf("       n) Suppress standardization: %s\n",jn[stanco1]);
    printf("       o) Iteration step limit: %d\n",isl);
    printf("       q) Start of calculations\n\
Enter a letter, if you want to change the default settings\n");
    scanf ("%s", co);
    switch (co[0])
    {
      case 'a':
	printf("Number of search runs ");
	scanf("%d", &ad); break;
      case 'b':
	printf("Search probability increasing factor : ");
	scanf("%d", &mult); break;
      case 'c':
	auco=!auco; break;
      case 'd':
	printf("Weaker level: ");
	scanf("%lf", &g1);
	if (g2==g1)
	{
	  printf("Equal levels not allowed. Standard level changed.\n");
	  g2=g1/2;
	}  /* if */
	break;
      case 'e':
	printf("Standard level: ");
	scanf("%lf", &g2);
	if (g2==g1)
	{
	  if (auco)
	    printf("Equal levels not allowed. Weaker level changed.\n");
	  g1=g2*2;
	}  /* if */
	break;
      case 'f':
	printf("Number of data points for search start: ");
	scanf("%d", &sg); break;
      case 'g':
	sco=!sco; break;
      case 'h':
	printf ("Minimum cluster size: ");
	scanf ("%d", &mcg); break;
      case 'i':
	stanco=!stanco; break;
      case 'j':
	rco=!rco; break;
      case 'k':
	wco=!wco; break;
      case 'l':
	printf("Mahalanobis-cutoff value c for weaker level: ");
	scanf("%lf", &sf);
	g1=1-chi2(p,sf);
	if (g2==g1)
	{
	  printf("Equal levels not allowed. Standard level changed.\n");
	  g2=g1/2;
	} /* if */
	break;
      case 'm':
	printf("Mahalanobis-cutoff value c for standard level: ");
	scanf("%lf", &sf);
	g2=1-chi2(p,sf);
	if (g2==g1)
	{
	  if (auco)
	    printf("Equal levels not allowed. Weaker level changed.\n");
	  g1=g2*2;
	}  /* if */
	break;
     case 'n':
             stanco1=!stanco1; break;
     case 'o':
	     printf("Iteration step limit: ");
	     scanf("%d", &isl); break;
    } /* switch co */
  } /* while co!=q */
  fprintf(out,"\n\nSettings for cluster search:\n");
  fprintf(out,"        a) %d runs,\n", ad);
  fprintf(out,"        b) Increase factor of search probability for data not included in \n");
  fprintf(out,"           clusters: %d (integer !),\n", mult);
  fprintf(out,"        f) Number of data points for search start: %d \n", sg);
  fprintf(out,"        h) Minimum size of clusters: %d \n", mcg);
  fprintf(out,"        k) Do you want to enter points with decreased search probability: %s \n",jn[wco]);
  fprintf(out,"        o) Iteration step limit: %d\n\n",isl);
  if (stanco1)
    fprintf(out,"No standardization!\n\n");
  if (!stanco1)
  {
    printf("Standardizing...\n\n");
    standard();
  } /* if !stanco1 */
  else
  {
     for (i=0; i<p; ++i)
     {
        mx[i]=0; dx[i]=1;
     }
  }  /* else: stanco1 */
  if (stanco)
    stanausgabe();
  if (wco)
  {
    while (co[0]!='y')
    {
      printf("Enter 1: Probability decreased, 0: default \n");
      for (i=0; i<n; ++i)
      {
        if (ico)
          printf ("Value %s ", id[i]);
        else
          printf("Value %d ", i+1);
        scanf("%d", &gm[i]);
      }  /* for i */
      j=0;
		printf("Search probability decreased for points \n");
      for (i=0; i<n; ++i)
      {
        if (gm[i]==1)
        {
               ++j;
          if (ico)
            printf ("%11s ", id[i]);
          else
            printf ("%d ", i+1);
          if (j%6==0)
            printf ("\n");
        } /* if gm */
      } /* for i */
      printf ("\nCorrect ? (y/n) ");
      scanf ("%s", co);
    } /* while co[0] */
    j=0;
	 fprintf(out, "\nSearch probability decreased for points \n");
    for (i=0; i<n; ++i)
    {
      if (gm[i]==1)
		  {
		    ++j;
        if (ico)
          fprintf (out,"%11s ", id[i]);
        else
          fprintf (out,"%d ", i+1);
	      if (j%6==0)
          fprintf (out,"\n");
      } /* if gm */
    } /* for i */
    fprintf (out,"\n");
  } /* if wco */
  chial=chiinv(p,1-g2);
  if (auco)
    fprintf(out,"Low search level=%7.5f (corresponding to Mahalanobis-cutoff c1=%5.3f)\n",g1,chiinv(p,1-g1));
  fprintf(out, "Standard search level=%7.5f (corresponding to Mahalanobis-cutoff c2=%5.3f)\n", g2, chial);
  fprintf(out, "Corresponding outlier-regions for clusters: Mahalanobis distance point to center > cutoff\n");
  if (gvco)
    fprintf(out, "Initial grouping by %s \n",varname[p+2]);
  invers=schaetz(x, n);
  fprintf(out,"Estimators for the whole dataset \n");
  xqausgabe();
  sausgabe(invers);
  gl[0]=mult-((mult-1)*(gm[0]==1)); /* Initialisierung der Ziehungswahrscheinlichkeiten */
  for (i=1; i<n; ++i)
    gl[i]=gl[i-1]+1+(mult-1)*(gm[i]==0);
  fprintf(out,"1st run: Iteration start with whole dataset (WD-Cluster)\n");
  for (i=0; i<n; ++i)
    gi[i]=1;
/* TZ */ printf("WD-Cluster \n \n");
  ind2=2; ++zad;
  if (auco)    /* auco: Clustersuche auf 2 Leveln */
  {
    ind3=durchlauf(g1, -1);
/*    sca=sc; */
    j=0;
    for (i=0; i<n; ++i)
    {
      gj[i]=gi[i];
      if (gi[i]==0)
	++j;
    }  /* for i */
    ind2=2;
  }  /* if auco */
  ind3=durchlauf(g2, -1);
  if (!auco)
/*    sca=sc; */
    j=0;
  for (i=0; i<n; ++i)
  {
    gk[i]=gi[i];
    if (!auco)
    {
      if (gi[i]==0)
	++j;
    }  /* if !auco */
  }  /* for i */
  if (!heapco)
  {
    fprintf(out,"WARNING! Heap memory full! Program terminated.\nEnlarge minimum cluster size or Mahalanobis cutoff to get less clusters.\n");
    goto heapend;
  }
  if (j>=sg)
  {
/* TZ */ printf("Complement of WD-Cluster \n \n"); ++zad; mco=0;
    for (i=0; i<n; ++i)
    {
      if (auco)
	gi[i]=(!gj[i]);
      else
	gi[i]=(!gk[i]);
    } /* for i */
    ind2=1; ind3=1;
    if (auco)
      ind3=durchlauf(g1, -1);
    if (ind2 && ind3)
      ind3=durchlauf(g2, -1);
    if (!heapco)
    {
      fprintf(out,"WARNING! Heap memory full! Program terminated.\nEnlarge minimum cluster size or Mahalanobis cutoff to get less clusters.\n");
      goto heapend;
    }
  } /* if j>=sg */
  for (q=0; q<ad; ++q)
  {
/* TZ */ printf("Algorithm run %d \n \n", q+1);
    for (i=0; i<n; ++i)
      gi[i]=0;
    n2=sg;
    for (i=0; i<sg; ++i)  /* Auslosen der Startkonfiguration */
    {
	  rand02= gl[n-1]* (double) rand()/RAND_MAX;
	  j=-1;
	  do
	  {
	    ++j;
	    if (rand02<=gl[j])
	      ++gi[j];
	    if (gi[j]==2)
	    {
	      --gi[j]; --i;
	    } /* if */
	  } /* do */
	  while (rand02>gl[j]);
    } /* for i */
    ind2=1; mco=0;
    if (auco)
      ind3=durchlauf(g1, q);
    else
      ind3=1;
    if (ind2 && ind3)
      ind3=durchlauf(g2, q);
    if (!heapco)
    {
      fprintf(out,"WARNING! Heap memory full! Iterations terminated.\nEnlarge minimum cluster size or Mahalanobis cutoff to get less clusters.\nIteration run %d.\n",q+1);
      goto heapend;
    }
    if (sco)
    {
      if (stop(q))
	q=ad;
    } /* if sco */
  } /* for q */
  if (gvco)
  {
    mco=1;
    for(agn=0;agn<ngr;++agn)
    {
        ++zad;
  /* TZ */ printf("Cluster iteration with group %d \n \n", gnummer[agn]);
        fprintf(out, "* Iteration start with group %d: *\n", gnummer[agn]);
        n2=0;
	for (i=0; i<n; ++i)
        {
          gi[i]=(group[i]==gnummer[agn]); n2+=(group[i]==gnummer[agn]);
        } /* for i */
	ind2=1;
        if (n2>p)
        {
	  if (auco)
            ind3=durchlauf(g1, gnummer[agn]);
          else
            ind3=1;
          if (ind2 && ind3)
            ind3=durchlauf(g2, gnummer[agn]);
          if (!heapco)
          {
            fprintf(out,"WARNING! Heap memory full! Iterations terminated.\nEnlarge minimum cluster size or Mahalanobis cutoff to get less clusters.\n");
            goto heapend;
          }
        } /* if n2 */
        else
          fprintf(out,"Group has too few members.\n");
        fprintf(out,"\n  ***  \n");
    } /* for agn */
  } /* if gvco */
heapend:
  tabausgabe();
  fclose(out);
} /* main */

int stop(int q)
/* Bricht Verfahren ab, falls nach je 20 Durchgaengen gewuenscht */
/* Benoetigt globale Variablen n, gm */
{
int i, j;
char co[2];

  if ((q%20)==1)
  {
    j=0;
    for (i=0; i<n; ++i)
      if (gm[i]>0)
	j++;
    printf("%d values in relevant clusters (n=%d). Do you want to stop the search ? (y/n) ", j, n);
    scanf("%s", co);
    return(co[0]=='y');
  }
  else
    return(0);
} /* stop */

int durchlauf(double gam, int q)
/* Eine Clusteriteration, gestartet vom vorgegebenen gi */
/* Benoetigt globale Variable x, y, n, p, g1, g2, out, mco, mult, heapco */
/* Veraendert globale Variable n2, gi, gj, gk, gl, gm, sc, th0, r, ind2, convstop, isl,d */
/* Benoetigt Funktionen grausgabe, vg, lssch, lsscale, prog, vorhanden */
/* Benoetigt NKOR */
{
vektor xa[NKOR];
int i, ind3;
/* ind3: 1, wenn weiteriteriert werden soll */

  d=0;
  n2=grausgabe(((gam==g2) && auco) || q>=-1);
  do
  {
      ++d;
      if ((d>isl) && (d>1))
      {
        ind3=0;
        fprintf(out,"* Algorithm did not converge fast enough.\n Case information file gets number n%d.\n", convstop+1);
        fprintf(out,"* The actual configuration contains %d points. Parameters:\n", n2);
        xqausgabe();
        sausgabe(invers);
        fprintf(out,"\n  ***  \n");
        if (gam==g2)
        {
          ++convstop;
          rausgabe();
        } /* if gam==g2 */
        goto dcend;
      } /* if d>isl */ 
      n2=0;
      for (i=0; i<n; ++i)
      {
	if (gi[i]==1)
	{
	  vg(xa[n2],x[i],p);
	  ++n2;
	} /* if gi[i]==1 */
      } /* for i */
      invers=schaetz(xa, n2);
      ind3=prog(gam);
      if (!heapco)
        goto dcend;
      i=1;
  } /* do */
  while (ind3);
dcend:
  return (i);
} /* durchlauf */

void xqausgabe(void)
/* Ausgabe des Lokationsschaetzers */
/* Benoetigt globale Variable mx, dx, p, out */
/* Veraendert globale Variable s, xq */
/* Benoetigt Funktion vausgabe */
{
  int i;

  fprintf(out,"\nMean vector: \n");
  restandard(xq, s);
  for (i=1; i<p+1; ++i)
    fprintf(out,"%13s", varname[i]);
  fprintf(out,"\n");
  vausgabe(xq, p);
} /* xqausgabe */

void sausgabe(int invers)
/* Ausgabe der Kovarianzmatrix */
/* Benoetigt globale Variable s, p, sc */
/* Benoetigt Funktion vausgabe */
{
  int i;

  fprintf(out, "\nCovariance matrix :\n");
  for (i=1; i<p+1; ++i)
    fprintf(out,"%13s", varname[i]);
  fprintf(out,"\n");
  for (i=0; i<p; ++i)
    vausgabe(s[i], p);
  if (!invers)
    fprintf(out,"\nMatrix not numerically invertable! \n");
  fprintf(out,"\n");
} /* sausgabe */

void rausgabe(void)
/* Schreibt die Mahalanobis-Abstaende und Indikatoren formatiert in die Ausgabedatei */
/* Benoetigt globale Variable n, out, gi, r, ico, gvco, ngr, ig, group, gnummer, scz2, outname,d ,isl, convstop */
/* Veraendert globale Variable out2 */
{
  int i, j, gzaehler[NKOR], gztotal[NKOR];
  char outname2[NLEN], addi[6];

  strcpy(outname2, outname);
  if (d>isl)
    sprintf(addi, ".n%d", convstop);
  else
    sprintf(addi, ".%d", scz2);
  strcat(outname2,addi);
  if((out2=fopen(outname2,"w"))==NULL)
  {
        printf("Error: Opening of output file impossible. \n");
        exit(0);
  }/*  if out2 */
  if (d>isl)
    fprintf(out2,"Case information for not fully iterated cluster %d\n", convstop);
  else
    fprintf(out2,"Case information for cluster no. %d\n",scz2);
  for (i=0; i<ngr; ++i)
  {
    gzaehler[i]=0;
    gztotal[i]=0;
  } /* for i */
  if (ico)
    fprintf(out2,"\n%s - ",varname[0]);
  if (gvco)
    fprintf(out2,"%s - ",varname[p+2]);
  fprintf(out2, "Mahalanobis distance from cluster - cluster indicator\n");
/* TZ   printf("Test\n");*/
/* TZ   fprintf(out,"Test\n"); */
  for (i=0; i<n; i++)
  {
    if (ico)
      fprintf(out2, "%12s   ",id[i]);
    if (gvco)
    {
      fprintf(out2, "%5d  ",group[i]);
      for (j=0; j<ngr; ++j)
      {
        if (group[i]==gnummer[j])
          ++gztotal[j];
      }  /* for j */
   } /* if gvco */
   fprintf(out2, "%14.7g  %d\n", r[i],gi[i]);
   if (gi[i] && gvco)
   {
          for (j=0; j<ngr; ++j)
          {
            if (group[i]==gnummer[j])
              ++gzaehler[j];
          }  /* for j */
   } /* if gi[i] & gvco */
  }  /* for i */
/*  fclose(out2); */
  if (gvco)
  {
    fprintf(out2, "\n%s - number of cases from %s in cluster\n",varname[p+2],varname[p+2],scz2);
    for(j=0; j<ngr; ++j)
      fprintf(out2, "   %d   %d (of %d)\n",gnummer[j],gzaehler[j],gztotal[j]);
  } /* if gvco */
  fclose(out2);
}  /* rausgabe */


void vausgabe(double vek[], int n)
/* Schreibt den Vektor vek formatiert in die Ausgabedatei */
/* Benoetigt globale Variable out */
{
  int i;

  for (i=0; i<n; i++)
  {
	fprintf(out, "%13.7f ", vek[i]);
	if (i%5==4)
	  fprintf(out, "\n");
  }
  fprintf(out, "\n");
} /* vausgabe */

/* Modul PROG */

int prog(double gam)
/* Berechnung des Ausreiszeridentifikators mit GAMMA-Prognoseroehre */
/* Benoetigt globale Variable x, n, p, g1, g2, out, mco, mult, xq, mcg, invers, heapco */
/* Veraendert globale Variable chial, n2, gi, gj, gk, gl, gm, ind2, r, vr, scz1-2, gz1-2, gx1-2, gs1-2, d1co */
/* Benoetigt Funktionen mahalanobis, vresid, rausgabe, chiinv, grausgabe, xqausgabe, sausgabe, vorhanden */
/* Benoetigt M_PI */
{
  double q1, q2;
  int i, ind, ind1, ind3, j, outco, dummy;
  /* ind: 0, falls Iteration fertig; ind1: 1, falls Cluster relevant und nicht
     Allescluster; ind3: 1, falls Cluster bereits vorhanden; dummy: Dummy */
  char co[2];

  ind=0;
  ind1=(ind2!=2);
  chial=chiinv(p,1-gam);
  dummy=mahalanobis(x, xq, n); /* Hier immer dummy=1, da bereits in durchlauf kontrolliert */
  for (i=0; i<n; ++i)       /* Neuer Cluster: wer gehoert dazu ? */
  {
    if (gi[i]==0)
    {
      gi[i]=(r[i]<=chial);
      if (gi[i]!=0)
      {
	ind=1;
	++n2;
      }  /* if gi[i]!=0 */
    }  /* if gi[i]==0 */
    else
    {
      gi[i]=(r[i]<=chial);
      if (gi[i]==0)
      {
	ind=1;
	--n2;
      }  /* if gi[i]==0 */
    }  /* else (gi[i] sofort !=0) */
  } /* for i */
  if (!ind)                 /* Nichts hat sich veraendert */
  {
    outco=(n2>=mcg);            /* mcg: Kleinster relevanter Cluster fuer Ausgabe */
    if (mco && (!outco))
      fprintf(out,"* Iteration led to too small cluster *\n  *** \n\n");
    ind2=0;                   /* ind2=0: Iteration wird nicht fortgesetzt. */
    if (gam==g1)
    {
      for (i=0; i<n; ++i)
      {
	if (gi[i]!=gj[i])   /* g1-Cluster!=Allescluster */
	      ind2=1;
      }  /* for i */
      if (!ind2)            /* g1-Cluster==Allescluster */
      {
	++gz1[0];
        if (mco)
	      fprintf(out, "* Iteration led to WD-cluster. *\n  *** \n\n");
      } /* if !ind2 */
    } /* if gam==g1 */
    else
    {
      for (i=0; i<n; ++i)
      {
	if (gi[i]!=gk[i])  /* g2-Cluster!=Allescluster */
	  ind2=1;
      }  /* for i */
      if (!ind2)   /* g2-Cluster==Allescluster */
      {
	++gz2[0];
        if (mco)
	      fprintf(out, "* Iteration led to WD-cluster. *\n  *** \n\n");
      } /* if !ind2 */
    } /* else (gam==g2) */
    if (ind2 && outco)
    {              /* Brauchbarer Cluster!=Allescluster gefunden */
      ind3=vorhanden(gam);
      if (heapco)
      {
        if (ind3)  /* Iteration wird gestoppt */
        {
	  ind2=0;
	  if (gam==g1)
	    ++gz2[cn[ind3-1]];
        } /* if ind3 */
        else       /* Cluster neu! */
        {
	    if (gam==g1)
	    {
	      fprintf(out,"Successful run. \n");
	      fprintf(out,"Output of low level cluster:\n");
	    } /* if gam==g1 */
	    else
	    {
	      if (!auco)
	      {
	        fprintf(out,"Successful run. \n");
	      } /* if !auco */
	      fprintf(out, "\nOutput of standard level cluster no. %d:\n",scz2);
	    } /* else (gam==g2) */
	    xqausgabe();
            sausgabe(invers);
  /* Clusterqualitaet hier im FIXREG-Programm */
        } /* else (!ind3) */
      } /* if heapco */
      else
        goto progend;
    } /* if ind2 && outco */
    if ((gam==g2) && (ind2))
    {
      ind1=1;
      if (rco)
      {
	  printf ("Cluster found ! Contains following points: \n");
	  j=0;
	  for (i=0; i<n; ++i)
	  {
		if (gi[i]!=0)
		{
		  if (ico)
		    printf("%s ", id[i]);
		  else
		    printf("%4d ", i+1);
		  j++;
		  if (j%10==9)
		    printf("\n");
		} /* if gi[i]!=0 */
	  } /* for i */
	  printf("\n");
	  printf("Number of points: %d\n", n2);
	  printf("Is this cluster relevant ? (y/n)");
	  scanf("%s", co);
	  ind1=(co[0]=='y');
	  printf("Mahalanobis-distances to output file ? (y/n)");
	  scanf("%s", co);
	  if (co[0]=='y')
	    rausgabe();
      } /* if rco */
      else
      {
	  ind1=outco; /* Cluster gross genug fuer Ausgabe ? */
	  if (ind1)
	    rausgabe();
      } /* else (!rco) */
      if (ind1)  /* Justierung der Multiplikatoren: Punkt in Cluster => Geringere Auswahlwahrscheinlichkeit */
      {
	if (n2<=n-2*(p+3))
	{
	  if (gl[0]!=1)
	    gl[0]-=((mult-1)*(gi[0]==1));
	  for (i=1; i<n; ++i)
	  {
	    if (gi[i]==1)
	      gm[i]=1;
	    gl[i]=gl[i-1]+1+(mult-1)*(gm[i]==0);
	  } /* for i */
	} /* if n2 klein */
      } /* if ind1 */
    } /* if gam==g2 && ind2 */
    if (gam==g2)
      d1co=0;
  } /* if !ind */
  if (outco)
  {
      n2=grausgabe(ind);
      if (ind2 && (!ind))  /* Achtung! Wozu ist das gut? */
      {
        fprintf(out,"\n  ***  \n");
        if (gam==g1)
          mco=1;
      }
  } /* if outco */
progend:
  return (ind);
}  /* prog */

int vorhanden(double gam)
/* Nummer des Clusters, die gefunden wurde, falls schon vorhanden */
/* Veraendert globale Variablen gz1, gz2, gx1-2, gs1-2, gls, scz1, scz2, heapco, d1co */
/* Benoetigt globale Variable sc, th0 */
{
  int i, j, ind, test;
  int *sint;
  double *sdouble;

  ind=0;
  if (gam==g1)
  {
    for (i=0; i<scz1; ++i)
    {
       if (clgleich(g1,i))
       {
	 ind=i+1;
	 ++gz1[i];
	 i=scz1;
	 if (mco)
           fprintf(out,"* Iteration led to low level cluster no. %d. *\n  *** \n\n",ind);
       } /* if clgleich1 */
    } /* for i */
    if (!ind)
    {
       ++scz1;
       d1co=1;
       if (scz1%30==1)
       {
         test=1;
         sint=cn;
	 cn= (int *)realloc(cn, (1+scz1/30)*30*sizeof(int));
         if (cn==NULL)
         {
           test=0;
           cn=sint;
         }
         for(i=0; i<p; ++i)
         {
           sdouble=gx1[i];
           gx1[i]= (double *)realloc(gx1[i], (1+scz1/30)*30*sizeof(double));
           if (gx1[i]==NULL)
           {
             test=0;
             gx1[i]=sdouble;
           }
           for(j=0; j<p; ++j)
           {
             sdouble=gs1[i][j];
             gs1[i][j]= (double *)realloc(gs1[i][j], (1+scz1/30)*30*sizeof(double));
             if (gs1[i][j]==NULL)
             {
               test=0;
               gs1[i][j]=sdouble;
             }
           } /* for j */
         } /* for i */
         sint=gz1;
	 gz1= (int *)realloc(gz1, (1+scz1/30)*30*sizeof(int));
         if (gz1==NULL)
         {
           test=0;
           gz1=sint;
         }
	 if (test)
	 {
           for (i=0; i<p; ++i)
           {
             gx1[i][scz1-1]=xq[i];
             for (j=0; j<p; ++j)
               gs1[i][j][scz1-1]=s[i][j];
           } /* for i */
	   for (j=scz1; j<scz1+30; ++j)
	     gz1[j-1]=1;
	 } /* if test */
	 else
           heapco=0;
       } /* if scz1%30=1 */
       else
       {
           for (i=0; i<p; ++i)
           {
             gx1[i][scz1-1]=xq[i];
             for (j=0; j<p; ++j)
               gs1[i][j][scz1-1]=s[i][j];
           } /* for i */
       } /* else (scz1%30!=1) */
    } /* if !ind */
  } /* if gam==g1 */
  else
  {
    for (i=0; i<scz2; ++i)
    {
       if (clgleich(g2,i))
       {
	 ind=i+1;
	 ++gz2[i];
	 if (d1co && auco)
	   cn[scz1-1]=i;
	 i=scz2;
	 if (mco)
           fprintf(out,"* Iteration led to standard level cluster no. %d. *\n  *** \n\n",ind);
       } /* if clgleich2 */
    } /* for i */
    if (!ind)
    {
       ++scz2;
       if (auco)
         cn[scz1-1]=scz2-1;
       if (scz2%30==1)
       {
         test=1;
         for(i=0;i<p; ++i)
         {
           sdouble=gx2[i];
           gx2[i]= (double *)realloc(gx2[i], (1+scz2/30)*30*sizeof(double));
           if (gx2[i]==NULL)
           {
             test=0;
             gx2[i]=sdouble;
           }
           for(j=0; j<p; ++j)
           {
             sdouble=gs2[i][j];
             gs2[i][j]= (double *)realloc(gs2[i][j], (1+scz2/30)*30*sizeof(double));
             if (gs2[i][j]==NULL)
             {
               test=0;
               gs2[i][j]=sdouble;
             }
           } /* for j */
         } /* for i */
         sint=gz2;
	 gz2= (int *)realloc(gz2, (1+scz2/30)*30*sizeof(int));
         if (gz2==NULL)
         {
           test=0;
           gz2=sint;
         }
	 if (test)
	 {
           if (auco)
	     cn[scz1-1]=scz2-1;
           for (i=0; i<p; ++i)
           {
             gx2[i][scz2-1]=xq[i];
             for (j=0; j<p; ++j)
               gs2[i][j][scz2-1]=s[i][j];
           } /* for i */
	   for (j=scz2; j<scz2+30; ++j)
	     gz2[j-1]=1;
	 } /* if test */
	 else
         {
           heapco=0;
           --scz2;
         }
       } /* if scz2%30==1 */
       else
       {
           for (i=0; i<p; ++i)
           {
             gx2[i][scz2-1]=xq[i];
             for (j=0; j<p; ++j)
               gs2[i][j][scz2-1]=s[i][j];
           } /* for i */
       } /* else (scz2%30!=1) */
    } /* if !ind */
  } /* else (gam==g2) */
  return(ind);
} /* vorhanden */

int grausgabe(int ind)
/* Ausgabe des aktuellen Clusters in die Ausgabedatei */
/* Benoetigt globale Variable n, gi, out, ind2, ico, id */
{
  int i, j, gra;

  gra=(ind2) && (!ind);
  if (gra)
    fprintf (out, "\nCluster contains points\n");
  j=0;
  for (i=0; i<n; ++i)
  {
    if (gi[i]!=0)
    {
      if (gra)
      {
	if (ico)
	  fprintf(out, "%11s ", id[i]);
	else
	  fprintf(out, "%4d ", i+1);
      }  /* if gra */
      j++;
      if (j%6==0)
      {
	if (gra)
	  fprintf(out, "\n");
      } /* if j%6==0 */
    } /* if gi[i]!=0 */
  } /* for i */
  if (gra)
  {
    fprintf(out, "\nCluster contains %d points", j);
    fprintf(out, "\n");
  } /* if gra */
  return(j);
} /* grausgabe */

void tabausgabe(void)
/* Ausgabe der Uebereinstimmungstabelle der g2-Cluster */
/* Benoetigt globale Variable gx2, scz2, gs2, n, p, x, y, g2, ad, heapco */
/* Veraendert globale Variable r, gi, sc, th0, chial */
/* Benoetigt Funktionen progy, vresid */
{
vektor th0;
double chial;
int i, j, k, l, gn, start=0, dummy, zaehler=0;

/* TZ */ printf ("Calculation of cluster similarity table\n");
  fprintf(out,"\n* Cluster similarity table *\nTotal number of standard level clusters: %d\n",scz2);
  fprintf(out,"Number of points in the intersection of standard level clusters no.\n\n");
  chial=chiinv(p,1-g2);
  do
  {
    fprintf(out,"No.  Total  ");
    if (n>999)
      fprintf(out," ");
    if (n>9999)
      fprintf(out," ");
    for (i=start; (i<scz2 && i<start+10); ++i)
    {
      if (i<9)
	fprintf(out," ");
      if (i<99)
	fprintf(out," ");
      fprintf(out,"%d  ", i+1);
      if (n>999)
        fprintf(out," ");
      if (n>9999)
        fprintf(out," ");
    } /* for i */
    fprintf(out,"\n");
    fprintf(out,"Times found ");
    if (n>999)
      fprintf(out," ");
    if (n>9999)
      fprintf(out," ");
    for (i=start; (i<scz2 && i<start+10); ++i)
    {
      if (gz2[i]<10)
	fprintf(out," ");
      if (gz2[i]<100)
	fprintf(out," ");
      if ((n>999) && (gz2[i]<1000))
	fprintf(out," ");
      if ((n>9999) && (gz2[i]<10000))
	fprintf(out," ");
      fprintf(out,"%d  ", gz2[i]);
      zaehler+=gz2[i];
    } /* for i */
    fprintf(out,"\n\n");
    for (i=0; i<scz2; ++i)
    {
      if (i<9)
	fprintf(out," ");
      if (i<99)
	fprintf(out," ");
      fprintf(out,"%d  ", i+1);
      gn=0;
      for (j=0; j<p; ++j)
      {
        th0[j]=gx2[j][i];
        for (k=0; k<p; ++k)
          s[j][k]=gs2[j][k][i];
      } /* for j */
      dummy=mahalanobis(x, th0, n);
      for (j=0; j<n; ++j)
      {
	gi[j]=(r[j]<=chial);
	gn+=gi[j];
      } /* for j */
      if (gn<10)
	fprintf(out," ");
      if (gn<100)
	fprintf(out," ");
      if ((n>999) && (gn<1000))
	fprintf(out," ");
      if ((n>9999) && (gn<10000))
	fprintf(out," ");
      fprintf(out,"  %d  ", gn);
      for (j=start; (j<scz2 && j<start+10); ++j)
      {
	if (j<i+1)
        {
	  fprintf(out,"     ");
          if (n>999)
	    fprintf(out," ");
          if (n>9999)
	    fprintf(out," ");
        } /* if j */
        else
        {
           gn=0;
           if (j<start)
             j=start;
           for (l=0; l<p; ++l)
           {
             th0[l]=gx2[l][j];
             for (k=0; k<p; ++k)
               s[l][k]=gs2[l][k][j];
           } /* for l */
	   dummy=mahalanobis(x, th0, n);
	   for (k=0; k<n; ++k)
	     gn+=(gi[k] && (gi[k]==(r[k]<=chial)));
           if (gn<10)
             fprintf(out," ");
           if (gn<100)
             fprintf(out," ");
           if ((n>999) && (gn<1000))
              fprintf(out," ");
           if ((n>9999) && (gn<10000))
              fprintf(out," ");
           fprintf(out,"%d  ", gn);
        } /* else (j>i) */
      } /* for j */
      fprintf(out,"\n");
    } /* for i */
    start+=10;
  } /* do */
  while (start<scz2);
  fprintf(out,"\n%d iterations did not finish fast enough.\n",convstop);
  zaehler+=convstop;
  if (heapco)
    fprintf(out,"\n%d iterations led to too small clusters.\n",ad+zad-zaehler);
} /* tabausgabe */

int clgleich (double gam, int nr)
/* 1, wenn xq==gx1/2, gs1/2==s */
/* Benoetigt globale Variable xq, s, p, gx1/2, gs1/2, g1/2 */
/* Benoetigt Prozedur xqgleich */
{
int i, j, k;

  if (gam==g1)
  {
    k=1;
    for (i=0; i<p; ++i)
    {
      for (j=0; j<p; ++j)
        if (s[i][j]!=gs1[i][j][nr])
          k=0;
    }
  }
  else
  {
    k=1;
    for (i=0; i<p; ++i)
    {
      for (j=0; j<p; ++j)
        if (s[i][j]!=gs2[i][j][nr])
          k=0;
    }
  }
  if (k==1)
    k=xqgleich(gam, nr);
  return(k);
} /* clgleich */

int xqgleich (double gam, int nr)
/* 1, wenn xq==gx1/2 */
/* Benoetigt globale Variable xq, p, gx1, gx2, g1, g2 */
{
  int i,j;

  if (gam==g1)
  {
    j=1;
    for (i=0; i<p; ++i)
      if (xq[i]!=gx1[i][nr])
        j=0;
  }
  else
  {
    j=1;
    for (i=0; i<p; ++i)
      if (xq[i]!=gx2[i][nr])
        j=0;
  }
  return (j);
} /* xqgleich */
